function [G,vD,J_diag] = derivative_expm(logC)

n = size(logC,1);

[Q,L] = eig(logC);
vL = diag(L);
vD = zeros(n^2,1);
for i = 1:n
    for j = 1:n
        if abs(vL(i)-vL(j)) < 1e-14
            vD((i-1)*n+j) = exp(vL(i)); 
        else
            vD((i-1)*n+j) = (exp(vL(i))-exp(vL(j)))/(vL(i)-vL(j));
        end
    end
end
D = diag(vD);
G = kron(Q,Q)*D*kron(Q',Q');

G_diag = zeros(n);
for k = 1:n
    i = k + (k-1)*n;
    for l = 1:n
        j = l + (l-1)*n;
        G_diag(k,l) = G(i,j);
    end
end
J_diag = eye(n)-G_diag;